#include "lista_como_fila.h"

void cria(Fila *F) {
     F->inicio=NULL;
     F->fim=NULL;
}

void entra(Fila *F, elem *x, int *erro) {
     no *p;
     
     p=(no*) malloc(sizeof(no));
     if (p==NULL)
        *erro=1;
     else {
          *erro=0;
          p->info=*x;
          p->prox=NULL;
          if (F->inicio==NULL)
             F->inicio=p;
          else F->fim->prox=p;
          F->fim=p;
     }
}

void sai(Fila *F, elem *x, int *erro) {
     no *p;

     if (IsEmpty(F))
        *erro=1;
     else {
          *erro=0;
          p=F->inicio;
          *x=p->info;
          F->inicio=F->inicio->prox;
          free(p);
     }
}

int IsEmpty(Fila *F) {
    if (F->inicio==NULL)
       return(1);
    else return(0);
}

int IsFull(Fila *F) {
    no* p;
   
    p=(no*) malloc(sizeof(no));
    if (p==NULL)
       return(1);
    else {
         free(p);
         return(0);
    }
}
